SystemOrganization addCategory: #'PBE-LightsOut'!

PackageManifest subclass: #ManifestPBELightsOut
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PBE-LightsOut'!

!ManifestPBELightsOut commentStamp: '<historical>' prior: 0!
I store metadata for this package. These meta data are used by other tools such as the SmalllintManifestChecker and the critics Browser!

!ManifestPBELightsOut class methodsFor: 'code-critics' stamp: 'HubertRENAULT 7/21/2016 18:33'!
ruleRBNoClassCommentRuleV1FalsePositive
	^ #(#(#(#RGClassDefinition #(#LOCell)) #'2016-07-21T18:33:12.965984+02:00') )! !

BorderedMorph subclass: #LOGame
	instanceVariableNames: 'cells'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PBE-LightsOut'!

!LOGame methodsFor: 'as yet unclassified' stamp: 'HubertRENAULT 7/21/2016 18:48'!
cellsPerSide
	"Le nombre de cellules le long de chaque côté du jeu"
 ^ 10! !

!LOGame methodsFor: 'initialization' stamp: 'HubertRENAULT 7/21/2016 18:46'!
initialize
	| sampleCell width height n |
	super initialize.
	n := self cellsPerSide.
	sampleCell := LOCell new.
	width := sampleCell width.
	height := sampleCell height.
	self bounds: (5@5 extent: ((width*n) @(height*n)) + (2 * self borderWidth)).
	cells := Matrix new: n tabulate: [ :i :j | self newCellAt: i at: j ]! !

!LOGame methodsFor: 'instance creation' stamp: 'HubertRENAULT 7/21/2016 19:19'!
newCellAt: i at: j
	"Crée une cellule à la position (i,j) et l'ajoute dans ma représentation graphique à la
	position correcte. Retourne une nouvelle cellule"
	| c origin |
	c := LOCell new.
	origin := self innerBounds origin.
	self addMorph: c.
	c position: ((i - 1) * c width) @ ((j - 1) * c height) + origin.
	c mouseAction: [self toggleNeighboursOfCellAt: i at: j].
	^ c! !

!LOGame methodsFor: 'initialization' stamp: 'HubertRENAULT 7/21/2016 18:51'!
toggleNeighboursOfCellAt: i at: j
	(i > 1) ifTrue: [ (cells at: i - 1 at: j ) toggleState].
	(i < self cellsPerSide) ifTrue: [ (cells at: i + 1 at: j) toggleState].
	(j > 1) ifTrue: [ (cells at: i at: j - 1) toggleState].
	(j < self cellsPerSide) ifTrue: [ (cells at: i at: j + 1) toggleState]! !

SimpleSwitchMorph subclass: #LOCell
	instanceVariableNames: 'mouseAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PBE-LightsOut'!

!LOCell methodsFor: 'initialization' stamp: 'HubertRENAULT 7/21/2016 18:34'!
initialize
	super initialize.
	self label: ''.
	self borderWidth: 2.
	bounds := 0@0 corner: 16@16.
	offColor := Color paleYellow.
	onColor := Color paleBlue darker.
	self useSquareCorners.
	self turnOff! !

!LOCell methodsFor: 'accessing' stamp: 'HubertRENAULT 7/21/2016 18:53'!
mouseAction: aBlock
 ^ mouseAction := aBlock! !

!LOCell methodsFor: 'event handling' stamp: 'HubertRENAULT 7/21/2016 18:55'!
mouseUp: anEvent
	mouseAction value! !
